| LPCOpen Platform v1.03 LPCOpen Platform for NXP LPC Microcontrollers

- Main Page
- Modules
- Data Structures
- Files
- Related Pages

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Modules | Enumerations | Functions
Pipe Data Reading and Writing
Pipe Management

## Detailed Description

Pipe data read/write definitions.

Functions, macros, variables, enums and types related to data reading and writing from and to pipes.

## Modules
| Read/Write of Multi-Byte Streams
| Pipe data stream transmission and reception management.
| Read/Write of Primitive Data Types
| Pipe data primitive read/write definitions.

## Enumerations
enum | Pipe_WaitUntilReady_ErrorCodes_t { PIPE_READYWAIT_NoError = 0, PIPE_READYWAIT_PipeStalled = 1, PIPE_READYWAIT_DeviceDisconnected = 2, PIPE_READYWAIT_Timeout = 3 }

## Functions
static uint16_t | Pipe_BytesInPipe (const uint8_t corenum) ATTR_WARN_UNUSED_RESULT ATTR_ALWAYS_INLINE
| Indicates the number of bytes currently stored in the current pipes's selected bank.
uint8_t | Pipe_WaitUntilReady (const uint8_t corenum)
| Spin-loops until the currently selected non-control pipe is ready for the next packed of data to be read or written to it, aborting in the case of an error condition (such as a timeout or device disconnect).

## Enumeration Type Documentation

enum Pipe_WaitUntilReady_ErrorCodes_t

Enum for the possible error return codes of the Pipe_WaitUntilReady() function.

Enumerator:

  PIPE_READYWAIT_NoError | Pipe ready for next packet, no error.
  PIPE_READYWAIT_PipeStalled | The device stalled the pipe while waiting.
  PIPE_READYWAIT_DeviceDisconnected | Device was disconnected from the host while waiting.
  PIPE_READYWAIT_Timeout | The device failed to accept or send the next packet within the software timeout period set by the USB_STREAM_TIMEOUT_MS macro.

Definition at line 202 of file Pipe.h.

## Function Documentation

static uint16_t Pipe_BytesInPipe | ( | const uint8_t | corenum | ) |
| inline static

Indicates the number of bytes currently stored in the current pipes's selected bank.

Note
  The return width of this function may differ, depending on the maximum pipe bank size of the selected LPC model.

Parameters

  corenum | : USB port number

Returns
  Total number of bytes in the currently selected pipe's FIFO buffer

Definition at line 253 of file Pipe.h.

uint8_t Pipe_WaitUntilReady | ( | const uint8_t | corenum | ) |

Spin-loops until the currently selected non-control pipe is ready for the next packed of data to be read or written to it, aborting in the case of an error condition (such as a timeout or device disconnect).

Returns
  A value from the Pipe_WaitUntilReady_ErrorCodes_t enum

Definition at line 102 of file Pipe.c.